#include "isometricview.h"

double CIsometricView::get_denom()
{
	return xpx*ypy - xpy*ypx;
}

CIsometricView::CIsometricView()
{
	posx	= 0;
	posy	= 0;
	xpx		= 32;
	ypx		= 16;
	xpy		= -32;
	ypy		= 16;
	denom	= get_denom();
}

int CIsometricView::init(int srcx_per_x_axis,int srcy_per_x_axis,int srcx_per_y_axis,int srcy_per_y_axis)
{
	xpx	= (double)srcx_per_x_axis;
	ypx = (double)srcy_per_x_axis;
	xpy	= (double)srcx_per_y_axis;
	ypy	= (double)srcy_per_y_axis;

	//isoW߂ƂɎgʕ\ߎZoĂ܂B
	//xAbv܂A0ZG[h~ړIłB
	denom = get_denom();
	if(denom==0.0)
	{
		init();
		return -1;
	}
	return 0;
}
int CIsometricView::set_srcpos(int srcpos_x,int srcpos_y)
{
	posx	= (double)srcpos_x;
	posy	= (double)srcpos_y;
	return 0;
}

int CIsometricView::srcx(double isox,double isoy)
{
	return (int)(posx+(isox*xpx)+(isoy*xpy));
}
int CIsometricView::srcy(double isox,double isoy)
{
	return (int)(posy+(isox*ypx)+(isoy*ypy));
}
double CIsometricView::isox(int srcx,int srcy)
{
	return (((double)srcx-posx)*ypy-((double)srcy-posy)*xpy)/denom;
}
double CIsometricView::isoy(int srcx,int srcy)
{
	return (((double)srcx-posx)*ypx-((double)srcy-posy)*xpx)/(-denom);
}

int CIsometricView::srcpos_x(){return (int)posx;}
int CIsometricView::srcpos_y(){return (int)posy;}
int CIsometricView::srcx_per_x_axis(){return (int)xpx;}
int CIsometricView::srcy_per_x_axis(){return (int)ypx;}
int CIsometricView::srcx_per_y_axis(){return (int)xpy;}
int CIsometricView::srcy_per_y_axis(){return (int)ypy;}
